
{$APPTYPE GUI}{$MODE DELPHI}

program DemoTile3D;

uses
  SysUtils,windows,math,gl,glu,glext,GraphOGL;

//const
 
//type
  
var 
  tex:gluint;
   
  CharacterTable: PatternCharacterTable = 
  (
  'ddddddddddddddddddd.............',
  'ddddbbbbbbbbbbbbddd.............',
  'ddbbbaaaaaaaaabbbdd.............',
  'dbbaaaaacccccaabbddddd..........',   
  'dbaaccccccccccaabbbbbddd........', 
  'bbaaacccccccccccccccaabd........',
  'baaccccccccccccccccccabd........',
  'baccccccaccccccccabbabd.........',
  'ccccccaaaaacccccccaabbd.........',
  'cccccaaacccccccccabbbdd.........',
  'aaccccccccbbcccaabbddd..........',
  'aaaacaaabbddbbbbbbdd............',
  'aaaaaaabbddddddddd..............',
  'bbbbbbbbddd.....................',
  'ddddddd.........................',
  '................................',   
  '................................',
  '................................',
  '................................',
  '................................',   
  '................................', 
  '................................',
  '................................',
  '................................',
  '................................',
  '................................',
  '................................',
  '................................',
  '................................',
  '................................',
  '................................',
  '................................'); 
  
   
//{$R *.rc}
//{$R *.res}  


procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,tu,tv:glFloat;invert:boolean);
begin
  TwoSideON;
  if invert then glCullFace(GL_FRONT); 
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(1*tu,-1*tv, 0,-1*tv, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 1*tu,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  if invert then glCullFace(GL_BACK); 
  TwoSideOFF;  
end; 


procedure Tile1(x,y,z,size,h:glfloat;RepeatTexture:boolean);
var
  ts,tv:glfloat;
begin
  if RepeatTexture then begin ts:=size; tv:=h/size;end 
  else begin ts:=1; tv:=1/size;end;
  
  glPushMatrix;	
  glTranslatef(x,y,z); 
  TextureSelectID(1);  
  Quad(-size,h,-size, size,h,-size, -size,h,size, size,h,size, ts,ts,false);   // superiore
  TextureSelectID(0);  
  Quad(-size,0,-size, size,0,-size, -size,0,size, size,0,size, ts,ts,true);    // inferiore
  Quad(-size,h,size, size,h,size, -size,0,size, size,0,size, ts,tv,false);     // anteriore
  Quad(-size,h,-size, size,h,-size, -size,0,-size, size,0,-size, ts,tv,true);  // posteriore
  Quad(-size,h,-size, -size,h,size, -size,0,-size, -size,0,size, ts,tv,false); // sinistra
  Quad(size,h,-size, size,h,size, size,0,-size, size,0,size, ts,tv,true);       // destra
  glPopMatrix;  
end;


procedure Tile2(x,y,z,size,h:glfloat;RepeatTexture:boolean);
var
  ts,tv:glfloat;
begin
  if RepeatTexture then begin ts:=size; tv:=h/size;end 
  else begin ts:=1; tv:=1/size;end;
  
  glPushMatrix;	
  glTranslatef(x,y,z); 
  TextureSelectID(0);  
  Quad(-size,h,-size, size,h,-size, -size,h,size, size,h,size, ts,ts,false);   // superiore  
  Quad(-size,0,-size, size,0,-size, -size,0,size, size,0,size, ts,ts,true);    // inferiore
  Quad(-size,h,size, size,h,size, -size,0,size, size,0,size, ts,tv,false);     // anteriore
  Quad(-size,h,-size, size,h,-size, -size,0,-size, size,0,-size, ts,tv,true);  // posteriore
  Quad(-size,h,-size, -size,h,size, -size,0,-size, -size,0,size, ts,tv,false); // sinistra
  Quad(size,h,-size, size,h,size, size,0,-size, size,0,size, ts,tv,true);       // destra
  glPopMatrix;  
end;


procedure Tile3(x,y,z,size,h:glfloat;RepeatTexture:boolean);
var
  ts,tv:glfloat;
begin
  if RepeatTexture then begin ts:=size; tv:=h/size;end 
  else begin ts:=1; tv:=1/size;end;
  
  glPushMatrix;	
  glTranslatef(x,y,z); 
  TextureSelectID(2);  
  Quad(-size,h,-size, size,h,-size, -size,h,size, size,h,size, ts,ts,false);   // superiore  
  TextureSelectID(0);    
  Quad(-size,0,-size, size,0,-size, -size,0,size, size,0,size, ts,ts,true);    // inferiore
  Quad(-size,h,size, size,h,size, -size,0,size, size,0,size, ts,tv,false);     // anteriore
  Quad(-size,h,-size, size,h,-size, -size,0,-size, size,0,-size, ts,tv,true);  // posteriore
  Quad(-size,h,-size, -size,h,size, -size,0,-size, -size,0,size, ts,tv,false); // sinistra
  Quad(size,h,-size, size,h,size, size,0,-size, size,0,size, ts,tv,true);       // destra
  glPopMatrix;  
end;


procedure Tile4(x,y,z,size,h:glfloat;RepeatTexture:boolean);
var
  ts,tv:glfloat;
begin
  if RepeatTexture then begin ts:=size; tv:=h/size;end 
  else begin ts:=1; tv:=1/size;end;
 
  glPushMatrix;	
  glTranslatef(x,y,z);  
  glEnable(GL_BLEND);
  TextureSelectID(3);    
  Quad(-size,0,-size, size,0,-size, -size,0,size, size,0,size, ts,ts,false);   // inferiore  
  glDisable(GL_BLEND);  
  glPopMatrix;   
end;


procedure GenTile3D(x,y,z,size:glfloat;width,depth:integer;CharacterTable:PatternCharacterTable);
var
  s,t:integer;
   
begin
  // size  la dimensione delle tessere
  glPushMatrix;	
  glTranslatef(x-(width*size*2)/2+1,y,z-(depth*size*2)/2); 

  for t:=0 to width-1 do
  for s:=0 to depth-1 do 
  begin
    case CharacterTable[t][s]of
	  '.': begin end;
      'a': Tile1(s*size*2,0,t*size*2, size,size/2,false);    'b': Tile2(s*size*2,0,t*size*2, size,size/2,false); 
      'c': Tile3(s*size*2,0,t*size*2, size,size,false);      'd': Tile4(s*size*2,0,t*size*2, size,size/2,false);
      'e': begin end; 'f': begin end;
      'g': begin end; 'h': begin end;
      'i': begin end; 'j': begin end;
      'k': begin end; 'l': begin end;
      'm': begin end; 'n': begin end;
      'o': begin end; 'p': begin end;
      'q': begin end; 'r': begin end;
      's': begin end; 't': begin end;
      'u': begin end; 'v': begin end;
      'w': begin end; 'x': begin end;
      'y': begin end; 'z': begin end;
    end;	
  end;

  glPopMatrix;  
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
end;
begin 

  OpenGL_Texture();
  
  TextureLoadID('Floor04.bmp',0);  
  TextureLoadID('Floor05.bmp',1);
  TextureLoadID('Floor07.bmp',2);
  TextureLoadID('water4.bmp',3);  
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,-2,-25);        // regola l'inquadratura degli elementi nello schermo  
  glRotatef(25,1,0,0);    
  
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1);   
  
  SetglMouseMove(GL_M0,2);  

  GenTile3D(0,0,0, 0.5, 24,24,CharacterTable); 
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Demo Tile 3D - Struttura base', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
